#!/usr/bin/perl

use warnings;
use strict;

sub BEGIN
{
    push (@INC,$ENV{HOME}.'/download/leverloda/goanseech')
        if(!( (join(' ',@INC)) =~ /$ENV{HOME}\/\.leve\/lib/));
}

use Data::Dumper;
use POE;
use POE::Filter::Reference;
use POE::Component::Client::TCP;

#use POE::Component::Leve::leveShell;
use POE::Component::Leve::visualShell;
##############################################################################
=pod

=head1 NAME

patternQuery connects to a patternServer and allows to manipulate the data of
that server

=head1 AUTHOR

  Bruno Bttcher <bboett at adlp dot org>

=head1 COPYRIGHT and LICENCE

 Copyright (c) 2002 Bruno Boettcher

 patternQuery.pl is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; version 2
 of the License.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


=head3 instantiating a TCP client

Create a client that sends and receives Perl data structures.
Upon connecting with the server, it sends a list of things to
process.  The server responds with a hash of a few things.  Upon
receipt of that hash, the client displays its contents and exits.

=cut

my $rootpath = $ENV{HOME}."/.goanseech/";


while(scalar(@ARGV) >0)
{
  my $key = shift(@ARGV);
  if($key =~ /--config/i)
  {
    $rootpath = shift(@ARGV);
  }# if($key =~ /--config/i)
  else
  {
    die("Invalid switch: valid is --config\n");
  }# else
}# if(scalar(@ARGV) >0)
$rootpath .= "/" if(!($rootpath =~ /\/$/));

my $settings = do($rootpath."settings.pm");

#my $shell = new POE::Component::Leve::leveShell();
my $shell = new POE::Component::Leve::visualShell();

$shell->print("making the connection\n");


#POE::Component::Client::TCP->new
use ClientTcp;
my $clientSocket = 
ClientTcp->new
  ( 
    Alias => "pattern_client",
    RemoteAddress => "localhost",
    RemotePort    => 22345,
    Filter        => "POE::Filter::Reference",
    SSL => 1,

    # Build a request and send it.

    Connected => sub {
      my $heap = $_[HEAP];

      $shell->server($heap->{server});
      $shell->init();
      my @request = ( 
	      "auth ".$settings->{"user"}." ".$settings->{"passwd"},
	      "rawnames" 
	      );

      $heap->{server}->put( \@request );
      #print("shell initialized send out: ".Dumper(\@request)."\n");
      #$shell->prompt();
    },

    # Receive a response, display it, and shut down the client.

    ServerInput => sub {
        my ( $kernel, $hash ) = @_[ KERNEL, ARG0 ];

  #$kernel->post('delegate',"hello");
      #print("got input....!\n");

        if ( !$hash) 
	{
	  #ignore empty lines...
	}
        elsif ( ref($hash) =~ /nameContainer/ ) 
        {
            #$shell->print ("Client received a nameContainer type: ". ref($hash). " with $hash\n");
            #$shell->print ("dumping: ". Dumper($hash). "\n");
            #print "Client received:".Dumper($hash)."\n";
            #$shell->print ("Client received:".Dumper($hash)."\n");
	    my $list = $hash->{"listing"};
            #$shell->print ("listing:".Dumper($list)."\n");
            $shell->setargCompletions($list);
        }
        elsif ( ref($hash) eq 'HASH' ) 
	{
            #print "Client received:".Dumper($hash)."\n";
            #$shell->print ("Client received:".Dumper($hash)."\n");
            $shell->print (Dumper($hash)."\n");
        }
        elsif ( ref($hash) eq 'SCALAR' ) 
	{
            #print "Client received:".$$hash."\n";
            $shell->print ($$hash."\n");
        }
        else 
	{
            #print "Client received an unknown response type: ", ref($hash), " with $hash\n";
            $shell->print ("Client received an unknown response type: ". ref($hash). " with $hash\n");
        }

        #$kernel->yield("shutdown");
    },
    #could reach the server....
    ConnectError => sub {
      my ($heap,$kernel) = @_[HEAP,KERNEL];

  print("no socket generated!!\n");
  print("trying ot instantiate a server\n");
  system("nohup ./patternServer.pl &\n");
  print("patternserver instantiated and running\n");
  $_[KERNEL]->delay( reconnect => 5 );
    },
    Disconnected => sub {
      my ($heap,$kernel, $this) = @_[HEAP,KERNEL,OBJECT];
      $shell->print ("The server disconnected... from this ".ref($this)."\n");
      my $msg = "reconnecting in 5 secs if no instance is found starting a new one";
      $msg .= "\n";
      $shell->print ($msg);
  #system("nohup ./patternServer.pl &\n");
  $_[KERNEL]->delay( reconnect => 5 );
    },
  );

print("finished setting up the system, now runnong poe\n");
$poe_kernel->run();


__END__


=back

=head1 THANKS

I. Wronsky came up with the concept for leverloda
This gave B. Boettcher the incentive to begin this work, the
famous itching paradigm!

=head1 SEE ALSO

http://www.geocities.com/iwronsky/
http://poe.perl.org/

=cut

